# Source for file Array.php

Documentation is available at Array.php

1. <?php
2. /*
3. * $Id: Array.php 1495 2007-05-27 18:56:04Z zYne $
4. *
5. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6. * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7. * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8. * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9. * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10. * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11. * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12. * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13. * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14. * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15. * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16. *
17. * This software consists of voluntary contributions made by many individuals
18. * and is licensed under the LGPL. For more information, see
19. * <http://www.phpdoctrine.com>.
20. */
22. /**
23. * Doctrine_Cache_Interface
24. *
25. * @package Doctrine
26. * @subpackage Doctrine_Cache
27. * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
28. * @category Object Relational Mapping
29. * @link www.phpdoctrine.com
30. * @since 1.0
31. * @version $Revision: 1495 $
32. * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
33. */
34. class Doctrine_Cache_Array implements Countable, Doctrine_Cache_Interface
35. {
36. /**
37. * @var array $data an array of cached data
38. */
39. protected $data;
41. /**
42. * Test if a cache is available for the given id and (if yes) return it (false else)
43. *
44. * Note : return value is always "string" (unserialization is done by the core not by the backend)
45. *
46. * @param string $id cache id
47. * @param boolean $testCacheValidity if set to false, the cache validity won't be tested
48. * @return string cached datas (or false)
49. */
50. public function fetch($id, $testCacheValidity = true)
51. {
52. if (isset($this->data[$id])) {
53. return $this->data[$id];
54. }
55. return null;
56. }
57. /**
58. * Test if a cache is available or not (for the given id)
59. *
60. * @param string $id cache id
61. * @return mixed false (a cache is not available) or "last modified" timestamp (int) of the available cache record
62. */
63. public function contains($id)
64. {
65. return isset($this->data[$id]);
66. }
67. /**
68. * Save some string datas into a cache record
69. *
70. * Note : $data is always saved as a string
71. *
72. * @param string $data data to cache
73. * @param string $id cache id
74. * @param int $lifeTime if != false, set a specific lifetime for this cache record (null => infinite lifeTime)
75. * @return boolean true if no problem
76. */
77. public function save($id, $data, $lifeTime = false)
78. {
79. $this->data[$id] = $data;
80. }
81. /**
82. * Remove a cache record
83. *
84. * @param string $id cache id
85. * @return boolean true if no problem
86. */
87. public function delete($id)
88. {
89. unset($this->data[$id]);
90. }
91. /**
92. * Remove all cache record
93. *
94. * @return boolean true if no problem
95. */
96. public function deleteAll()
97. {
98. $this->data = array();
99. }
100. /**
101. * count
102. *
103. * @return integer
104. */
105. public function count()
106. {
107. return count($this->data);
108. }
109. }